Subject: Re: bug#74807: 30.0.90; Eglot: Non-Markdown strings rendered as Markdown

From: Troy Brown <[email-masked]>
Date: Wed, 8 Jan 2025 18:37:22 -0500

On Wed, Jan 8, 2025 at 4:18 AM João Távora <[email-masked]> wrote:
>
> > data point.  I think it's unwise to completely disregard that
> > information.
>
> I'm sure to treasure your remarks about my wisdom going forward.

I don't know why you feel the need to be condescending, nor why you
think it brings anything useful to this conversation.

> Other users may very well be content with the current Emacs behaviour,
> which gives them coloured documentation for ada-language-server.  If I
> change it in the direction you argue, I destroy this value and create no
> new value.  Is it still difficult to comprehend?

As you have pointed out, it appears Emacs' Markdown mode is the one
that renders this particular text that way.  I don't know what value
you think is added through inconsistency among LSP clients, it only
lessens the user's experience, and when Language Servers don't
directly target Eglot, it lessens the Emacs experience too
(considering Eglot's "built-in" package status).  Since you say you
are "concerned with longtime Eglot users", I would think this would be
important to you.

It was not the intention of the Language Server authors to have plain
text rendered as Markdown.  Additionally, it's not just colored text,
it may be underlined or italicised or something completely different
based on the user's theme, which looks completely out of place with
other documentation that doesn't happen to include characters which
trigger special Markdown rendering.

> > I am both a user of Eglot and a user of the language server and I'm
> > not happy with this behavior, nor do I think Eglot's behavior is
> > correct.  How is my experience any less important than any other user?
>
> Never said it is.  It's also no more important than other users.

I never said, nor implied that my experience was more important than
other users, I was only asking to be treated equally to your "longtime
Eglot users", whoever that encompasses.  Also, since Eglot is a
built-in Emacs package, I would think you'd be concerned with all
users of Eglot, not just "longtime users" and base decisions on
technical merit.

> > Moving on, I've done some digging and found historical information
> > that I believe is relevant.
>
> It's irrelevant, of course.  Markdown is specifically designed to render
> non marked-up aka "plain" text reasonably.  It would be much more
> relevant if you could actually find plaintext that Markdown mistakes for
> a link or something to get it to be actually harmful.
>
> Even then, because of what I've already stated, I'm not sure I'd change
> it.

It's not irrelevant, but I'm not going to debate it anymore as you
appear to be entrenched in your opinion.  I don't see the need to find
another example that somehow exceeds your personal tolerance level,
I've already demonstrated a perfectly reasonable example.

> If it's such a hill to die on, I'd spend my time arguing with the
> ada-language-server author to specifically provide those snippets inside
> a MarkupContent struct.

I probably will end up asking them to change this, but my approach is
to first try to correct a problem before I ask someone else to
workaround it.

Troy.